{$E+,N+} {Software CoProcessor emulation}
USES GUtils;

{$I 13THLOGO.PAS}

CONST
  XMax     = 320;
  YMax     = 200;
  XMaxDIV2 = XMax DIV 2;
  YMaxDIV2 = YMax DIV 2;

  NoFPoints = 150;
  Speed     = 10;
  Xc : Real = 6;
  Yc : Real = 6;
  Zc : Real = 500;
  SinTab : ARRAY[0..255] OF ShortInt = (
    0,2,5,7,10,12,15,17,20,22,24,27,29,31,34,36,38,41,43,45,47,49,52,54,
    56,58,60,62,64,66,67,69,71,73,74,76,78,79,81,82,83,85,86,87,88,90,91,
    92,93,93,94,95,96,97,97,98,98,99,99,99,100,100,100,100,100,100,100,
    100,99,99,99,98,98,97,97,96,95,95,94,93,92,91,90,89,88,87,85,84,83,
    81,80,78,77,75,73,72,70,68,66,65,63,61,59,57,55,53,51,48,46,44,42,40,
    37,35,33,30,28,26,23,21,18,16,14,11,9,6,4,1,-1,-4,-6,-9,-11,-14,-16,
    -18,-21,-23,-26,-28,-30,-33,-35,-37,-40,-42,-44,-46,-48,-51,-53,-55,
    -57,-59,-61,-63,-65,-66,-68,-70,-72,-73,-75,-77,-78,-80,-81,-83,-84,
    -85,-87,-88,-89,-90,-91,-92,-93,-94,-95,-95,-96,-97,-97,-98,-98,-99,
    -99,-99,-100,-100,-100,-100,-100,-100,-100,-100,-99,-99,-99,-98,-98,
    -97,-97,-96,-95,-94,-93,-93,-92,-91,-90,-88,-87,-86,-85,-83,-82,-81,
    -79,-78,-76,-74,-73,-71,-69,-67,-66,-64,-62,-60,-58,-56,-54,-52,-49,
    -47,-45,-43,-41,-38,-36,-34,-31,-29,-27,-24,-22,-20,-17,-15,-12,-10,
    -7,-5,-2,0);

TYPE
  _3DPoint = RECORD
               X,Y,Z: Integer;
             END;
  PointPos = ARRAY[0..NofPoints] OF _3DPoint;

VAR
  Point: PointPos;

 PROCEDURE PutPixel(X,Y:Word; C:Byte); ASSEMBLER;
 ASM
	MOV	AX, $A000
	MOV	ES, AX
	MOV	AX, XMax
	MOV	CX, Y
	MUL	CX
	ADD	AX, X
	MOV	DI, AX
	MOV	AL, C
	MOV	[ES:DI], AL
 END;

 FUNCTION GetPixel(X,Y:Word):Byte; ASSEMBLER;
 ASM
	MOV	AX, $A000
	MOV	ES, AX
	MOV	AX, XMax
	MOV	CX, Y
	MUL	CX
	ADD	AX, X
	MOV	DI, AX
	MOV	AL, [ES:DI]
 END;


{----------------------------------------------------------------------------}
PROCEDURE Init;
VAR I:Byte;
BEGIN
  Randomize;
  FOR I := 0 TO NofPoints DO
  BEGIN
    Point[I].X := Random(250)-125;
    Point[I].Y := Random(250)-125;
    Point[I].Z := Random(250)-125;
  END;
END;

FUNCTION Sinus  (Idx:Byte): Real; BEGIN Sinus   := SinTab[Idx]/100; END;
FUNCTION Cosinus(Idx:Byte): Real; BEGIN Cosinus := SinTab[(Idx+192) MOD 255]/100; END;





{----------------------------------------------------------------------------}
PROCEDURE DoRotation;
CONST
  Xstep = 1;
  Ystep = 1;
  Zstep = -1;

VAR
  Xp,Yp         : ARRAY[0..NofPoints] OF Word;
  X,Y,Z,X1,Y1,Z1: Real;
  PhiX,PhiY,PhiZ: Byte;
  I,Color       : Byte;
  TempX,TempY   : Word;

FUNCTION OK:Boolean;
VAR C:Byte;
BEGIN
  C := GetPixel(TempX,TempY);
  IF C <= 15 THEN OK := False ELSE OK := True;
  IF C  =  0 THEN OK := True;
END;

BEGIN
  PhiX := 0;
  PhiY := 0;
  PhiZ := 0;
  REPEAT
    ASM
	MOV	DX, 03DAh
 @VRetrace:
	IN	AL, DX
	TEST	AL, 8
	JZ	@VRetrace
    END;
    FOR I := 0 TO NofPoints DO
    BEGIN
      TempX := Xp[I]+XMaxDIV2;
      TempY := Yp[I]+YMaxDIV2;
      IF (TempX < XMax) AND (TempY < YMax) AND OK THEN PutPixel(TempX,TempY,0);

      X1 := Cosinus(PhiY)*Point[I].X-Sinus(PhiY)  *Point[I].Z;
      Z1 := Sinus(PhiY)  *Point[I].X+Cosinus(PhiY)*Point[I].Z;
      X  := Cosinus(PhiZ)*X1        +Sinus(PhiZ)  *Point[I].Y;
      Y1 := Cosinus(PhiZ)*Point[I].Y-Sinus(PhiZ)  *X1;
      Z  := Cosinus(PhiX)*Z1        -Sinus(PhiX)  *Y1;
      Y  := Sinus(PhiX)  *Z1        +Cosinus(PhiX)*Y1;

      Xp[I] := Round((Xc*Z-X*Zc)/(Z-Zc));
      Yp[I] := Round((Yc*Z-Y*Zc)/(Z-Zc));
      TempX := Xp[I]+XMaxDIV2;
      TempY := Yp[I]+YMaxDIV2;
      IF (TempX < XMax) AND (TempY < YMax) AND OK THEN
      BEGIN
        Color := 31+Round(Z/7);
        IF Color > 31
          THEN Color := 31
          ELSE IF Color < 16
                 THEN Color := 16;
        PutPixel(TempX,TempY,Color);
      END;
      Inc(Point[I].Z,Speed);
      IF Point[I].Z > 125 THEN Point[I].Z := -125;
    END;
    Inc(PhiX, XStep);
    Inc(PhiY, YStep);
    Inc(PhiZ, ZStep);
  UNTIL KeyPressed;
END;
{----------------------------------------------------------------------------}

PROCEDURE Show;
VAR BufIndex,PictIndex:Word;
    Color,I:Byte; Counter:Byte;
BEGIN
  BufIndex := 0;
  PictIndex := 0;
  REPEAT
    Inc(BufIndex);
    Counter := LOGO[BufIndex];
    IF Counter >= 240
      THEN BEGIN
             Color := Counter - 240;
             Mem[$A000:PictIndex] := Color;
             Inc(PictIndex);
           END
      ELSE BEGIN
             Inc(BufIndex);
             Color := LOGO[BufIndex];
             FOR I := 1 TO Counter DO
             BEGIN
               Mem[$A000:PictIndex] := Color;
               Inc(PictIndex);
             END;
           END;
  UNTIL PictIndex = 64000;
END;


BEGIN
  IF NOT VGASystem THEN
  BEGIN
    Writeln('Sorry man! This works only on VGA and above!');
    Halt;
  END;
  SetVideoMode($13);
  VgaScreenOff;
  Init;
  Show;
  VgaScreenOn;
  DoRotation;
  SetVideoMode($3);
  Writeln('CODE: The GodFather');
  Writeln('LOGO: Nikolay Cvetkov');
END.